package ovh.herisson.Clyde;

import org.hibernate.engine.jdbc.connections.spi.JdbcConnectionAccess;
import org.hibernate.engine.spi.SharedSessionContractImplementor;
import org.hibernate.id.IdentifierGenerator;

import java.sql.*;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class RegNoGenerator implements IdentifierGenerator {
    private final UserSaveCounter usv = UserSaveCounter.getInstance();
    @Override
    public Object generate(SharedSessionContractImplementor session, Object object) {
        try{
            JdbcConnectionAccess jdbccon = session.getJdbcConnectionAccess();
            Connection conn = jdbccon.obtainConnection();

            Statement statement = conn.createStatement();

            int n = usv.getCount();
            String query = "select count(reg_no)+"+n+" from Users";
            usv.increment();

            ResultSet set = statement.executeQuery(query);
            long resp = 0;
            Calendar c = new GregorianCalendar();
            if(set.next()){
                resp = set.getLong(1)+((c.get(Calendar.YEAR)%1000)*10000);
                System.out.println(resp);
            }

            conn.close();
            statement.close();

            return resp;

        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
}
